using System;
using System.Configuration;

using System.Data;
using System.Data.OleDb;

public class ExcelForm : System.Windows.Forms.Form
{
	private OleDbDataAdapter da;
	private DataTable dt;

	private System.Windows.Forms.DataGrid dataGrid;
	private System.Windows.Forms.Button updateButton;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public ExcelForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.updateButton = new System.Windows.Forms.Button();
		this.dataGrid = new System.Windows.Forms.DataGrid();
		((System.ComponentModel.ISupportInitialize)(this.dataGrid)).BeginInit();
		this.SuspendLayout();
		// 
		// updateButton
		// 
		this.updateButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
		this.updateButton.Location = new System.Drawing.Point(408, 232);
		this.updateButton.Name = "updateButton";
		this.updateButton.TabIndex = 0;
		this.updateButton.Text = "Update";
		this.updateButton.Click += new System.EventHandler(this.updateButton_Click);
		// 
		// dataGrid
		// 
		this.dataGrid.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
			| System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right)));
		this.dataGrid.DataMember = "";
		this.dataGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
		this.dataGrid.Location = new System.Drawing.Point(8, 8);
		this.dataGrid.Name = "dataGrid";
		this.dataGrid.Size = new System.Drawing.Size(476, 216);
		this.dataGrid.TabIndex = 1;
		// 
		// ExcelForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(492, 266);
		this.Controls.Add(this.dataGrid);
		this.Controls.Add(this.updateButton);
		this.Name = "ExcelForm";
		this.Text = "1.02 ExcelForm";
		this.Load += new System.EventHandler(this.ExcelForm_Load);
		((System.ComponentModel.ISupportInitialize)(this.dataGrid)).EndInit();
		this.ResumeLayout(false);

	}
	#endregion

	private void ExcelForm_Load(object sender, System.EventArgs e)
	{
		// create the DataAdapter
		da = new OleDbDataAdapter("SELECT * FROM [Sheet1$]",
			ConfigurationSettings.AppSettings["Excel_0115_ConnectString"]);

		// create the insert command
		String insertSql = "INSERT INTO [Sheet1$] " +
			"(CategoryID, CategoryName, Description) " +
			"VALUES (?, ?, ?)";
		da.InsertCommand = new OleDbCommand(insertSql, da.SelectCommand.Connection);
		da.InsertCommand.Parameters.Add("@CategoryID", OleDbType.Integer, 0, "CategoryID");
		da.InsertCommand.Parameters.Add("@CategoryName", OleDbType.Char, 15, "CategoryName");
		da.InsertCommand.Parameters.Add("@Description", OleDbType.VarChar, 100,	"Description");

		// create the update command
		String updateSql = "UPDATE [Sheet1$] " +
			"SET CategoryName=?, Description=? " +
			"WHERE CategoryID=?";
		da.UpdateCommand = new OleDbCommand(updateSql, da.SelectCommand.Connection);
		da.UpdateCommand.Parameters.Add("@CategoryName", OleDbType.Char, 15, "CategoryName");
		da.UpdateCommand.Parameters.Add("@Description", OleDbType.VarChar, 100, "Description");
		da.UpdateCommand.Parameters.Add("@CategoryID", OleDbType.Integer, 0, "CategoryID");

		// fill the table from the Excel spreadsheet
		dt = new DataTable();
		da.Fill(dt);
		// define the primary key
		dt.PrimaryKey = new DataColumn[] {dt.Columns[0]};

		// records can only be inserted using this technique
		dt.DefaultView.AllowDelete = false;
		dt.DefaultView.AllowEdit = true;
		dt.DefaultView.AllowNew = true;
		// bind the default view of the table to the grid
		dataGrid.DataSource = dt.DefaultView;}

	private void updateButton_Click(object sender, System.EventArgs e)
	{
		da.Update(dt);
	}

}