using System;
using System.Configuration;

using System.Data;
using System.Data.SqlClient;

public class NullParameterForm : System.Windows.Forms.Form
{
	private System.Windows.Forms.Label label1;
	private System.Windows.Forms.CheckBox isNullCheckBox;
	private System.Windows.Forms.Button goButton;
	private System.Windows.Forms.TextBox parameterTextBox;
	private System.Windows.Forms.TextBox resultTextBox;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public NullParameterForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.goButton = new System.Windows.Forms.Button();
		this.parameterTextBox = new System.Windows.Forms.TextBox();
		this.label1 = new System.Windows.Forms.Label();
		this.isNullCheckBox = new System.Windows.Forms.CheckBox();
		this.resultTextBox = new System.Windows.Forms.TextBox();
		this.SuspendLayout();
		// 
		// goButton
		// 
		this.goButton.Location = new System.Drawing.Point(240, 8);
		this.goButton.Name = "goButton";
		this.goButton.TabIndex = 0;
		this.goButton.Text = "Go";
		this.goButton.Click += new System.EventHandler(this.goButton_Click);
		// 
		// parameterTextBox
		// 
		this.parameterTextBox.Location = new System.Drawing.Point(112, 8);
		this.parameterTextBox.Name = "parameterTextBox";
		this.parameterTextBox.TabIndex = 1;
		this.parameterTextBox.Text = "";
		// 
		// label1
		// 
		this.label1.Location = new System.Drawing.Point(8, 8);
		this.label1.Name = "label1";
		this.label1.Size = new System.Drawing.Size(96, 16);
		this.label1.TabIndex = 2;
		this.label1.Text = "Parameter  (Int32)";
		// 
		// isNullCheckBox
		// 
		this.isNullCheckBox.Location = new System.Drawing.Point(8, 32);
		this.isNullCheckBox.Name = "isNullCheckBox";
		this.isNullCheckBox.TabIndex = 3;
		this.isNullCheckBox.Text = "Null Parameter";
		this.isNullCheckBox.CheckedChanged += new System.EventHandler(this.isNullCheckBox_CheckedChanged);
		// 
		// resultTextBox
		// 
		this.resultTextBox.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
			| System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right);
		this.resultTextBox.Location = new System.Drawing.Point(8, 64);
		this.resultTextBox.Multiline = true;
		this.resultTextBox.Name = "resultTextBox";
		this.resultTextBox.ReadOnly = true;
		this.resultTextBox.Size = new System.Drawing.Size(304, 192);
		this.resultTextBox.TabIndex = 4;
		this.resultTextBox.Text = "";
		// 
		// NullParameterForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(320, 266);
		this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		this.resultTextBox,
																		this.isNullCheckBox,
																		this.label1,
																		this.parameterTextBox,
																		this.goButton});
		this.Name = "NullParameterForm";
		this.Text = "2.14 NullParameterForm";
		this.ResumeLayout(false);

	}
	#endregion

	private void goButton_Click(object sender, System.EventArgs e)
	{
		// create the connection
		SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["Sql_ConnectString"]);
		
		// create the stored procedure command
		SqlCommand cmd = new SqlCommand("SP0214_NullParameter", conn);
		cmd.CommandType = CommandType.StoredProcedure;

		// define the parameter
		cmd.Parameters.Add("@ValueIn", SqlDbType.Int);
		// set the value of the paramter
		if (isNullCheckBox.Checked)
			cmd.Parameters[0].Value = System.DBNull.Value;
		else
			cmd.Parameters[0].Value = parameterTextBox.Text;

		// retrieve whether parameter null from stored procedure
		try
		{
			conn.Open();
			bool isNullParm = Convert.ToBoolean(cmd.ExecuteScalar());
			resultTextBox.Text = "Null Parameter = " + isNullParm;
		}
		catch (Exception ex)
		{
			resultTextBox.Text = ex.Message;
		}
		finally
		{
			conn.Close();
		}
	}

	private void isNullCheckBox_CheckedChanged(object sender, System.EventArgs e)
	{
		if(isNullCheckBox.Checked)
			parameterTextBox.Text = "";

		parameterTextBox.Enabled = !isNullCheckBox.Checked;
	}
}