using System;
using System.Configuration;
using System.Text;

using System.Data;
using System.Data.OracleClient;

public class OracleRefCursorsForm : System.Windows.Forms.Form
{
	private System.Windows.Forms.Button goButton;
	private System.Windows.Forms.DataGrid dataGrid;
	private System.Windows.Forms.Label label1;
	private System.Windows.Forms.TextBox customerIdTextBox;
	private System.Windows.Forms.Label label2;
	private System.Windows.Forms.TextBox resultTextBox;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public OracleRefCursorsForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.goButton = new System.Windows.Forms.Button();
		this.dataGrid = new System.Windows.Forms.DataGrid();
		this.customerIdTextBox = new System.Windows.Forms.TextBox();
		this.label1 = new System.Windows.Forms.Label();
		this.label2 = new System.Windows.Forms.Label();
		this.resultTextBox = new System.Windows.Forms.TextBox();
		((System.ComponentModel.ISupportInitialize)(this.dataGrid)).BeginInit();
		this.SuspendLayout();
		// 
		// goButton
		// 
		this.goButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
		this.goButton.Location = new System.Drawing.Point(408, 8);
		this.goButton.Name = "goButton";
		this.goButton.TabIndex = 0;
		this.goButton.Text = "Go";
		this.goButton.Click += new System.EventHandler(this.goButton_Click);
		// 
		// dataGrid
		// 
		this.dataGrid.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
			| System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right)));
		this.dataGrid.CaptionText = "DataSet";
		this.dataGrid.DataMember = "";
		this.dataGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
		this.dataGrid.Location = new System.Drawing.Point(8, 40);
		this.dataGrid.Name = "dataGrid";
		this.dataGrid.Size = new System.Drawing.Size(476, 192);
		this.dataGrid.TabIndex = 1;
		// 
		// customerIdTextBox
		// 
		this.customerIdTextBox.Location = new System.Drawing.Point(88, 8);
		this.customerIdTextBox.MaxLength = 5;
		this.customerIdTextBox.Name = "customerIdTextBox";
		this.customerIdTextBox.Size = new System.Drawing.Size(56, 20);
		this.customerIdTextBox.TabIndex = 2;
		this.customerIdTextBox.Text = "";
		// 
		// label1
		// 
		this.label1.Location = new System.Drawing.Point(8, 12);
		this.label1.Name = "label1";
		this.label1.Size = new System.Drawing.Size(72, 23);
		this.label1.TabIndex = 3;
		this.label1.Text = "Customer ID;";
		// 
		// label2
		// 
		this.label2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
		this.label2.Location = new System.Drawing.Point(8, 248);
		this.label2.Name = "label2";
		this.label2.Size = new System.Drawing.Size(100, 16);
		this.label2.TabIndex = 4;
		this.label2.Text = "DataReader";
		// 
		// resultTextBox
		// 
		this.resultTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right)));
		this.resultTextBox.Location = new System.Drawing.Point(8, 264);
		this.resultTextBox.Multiline = true;
		this.resultTextBox.Name = "resultTextBox";
		this.resultTextBox.ReadOnly = true;
		this.resultTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
		this.resultTextBox.Size = new System.Drawing.Size(472, 192);
		this.resultTextBox.TabIndex = 5;
		this.resultTextBox.TabStop = false;
		this.resultTextBox.Text = "";
		this.resultTextBox.WordWrap = false;
		// 
		// OracleRefCursorsForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(492, 466);
		this.Controls.Add(this.resultTextBox);
		this.Controls.Add(this.label2);
		this.Controls.Add(this.label1);
		this.Controls.Add(this.customerIdTextBox);
		this.Controls.Add(this.dataGrid);
		this.Controls.Add(this.goButton);
		this.Name = "OracleRefCursorsForm";
		this.Text = "2.21 OracleRefCursorsForm";
		((System.ComponentModel.ISupportInitialize)(this.dataGrid)).EndInit();
		this.ResumeLayout(false);

	}
	#endregion

	private void goButton_Click(object sender, System.EventArgs e)
	{
		// create the connection
		OracleConnection conn = new OracleConnection(ConfigurationSettings.AppSettings["Oracle_ConnectString"]);

		// create the command for the Oracle package
		OracleCommand cmd = new OracleCommand();
		cmd.Connection = conn;
		cmd.CommandType = CommandType.StoredProcedure;
		cmd.CommandText = "CURSPKG.GetCustomerOrdersWithDetails";
		// add the parameters
		cmd.Parameters.Add("pCustomerID", OracleType.Char, 5);
		cmd.Parameters.Add("curOrders", OracleType.Cursor).Direction = ParameterDirection.Output;
		cmd.Parameters.Add("curOrderDetails", OracleType.Cursor).Direction = ParameterDirection.Output;
		// set the Customer ID parameter value to user entry
		customerIdTextBox.Text = customerIdTextBox.Text.ToUpper();
		cmd.Parameters["pCustomerID"].Value = customerIdTextBox.Text;

		// create the DataAdapter and table mappings
		OracleDataAdapter da = new OracleDataAdapter(cmd);
		da.TableMappings.Add("Table", "ORDERS");
		da.TableMappings.Add("Table1", "ORDERDETAILS");


		// fill the DataSet from the Oracle package
		DataSet ds = new DataSet();
		da.Fill(ds);

		// create a relation
		ds.Relations.Add("ORDERS_ORDERDETAILS_RELATION",
			ds.Tables["ORDERS"].Columns["ORDERID"],
			ds.Tables["ORDERDETAILS"].Columns["ORDERID"]);

		// bind the default view for the Orders table to the grid
		dataGrid.DataSource = ds.Tables["ORDERS"].DefaultView;

		
		// create the DataReader from the Oracle package
		conn.Open();
		OracleDataReader dr = cmd.ExecuteReader();
		
		// output the Orders table for the customer
		StringBuilder result = new StringBuilder("ORDERS" + Environment.NewLine);
		while(dr.Read())
		{
			for(int i = 0; i < dr.FieldCount; i++)
				result.Append(dr[i].ToString() + "; ");

			result.Append(Environment.NewLine);
		}

		// move to the REF CURSOR for the next result set
		dr.NextResult();

		// output the Order Details for the customer
		result.Append(Environment.NewLine + "ORDER DETAILS" + Environment.NewLine);
		while(dr.Read())
		{
			for(int i = 0; i < dr.FieldCount; i++)
				result.Append(dr[i].ToString() + "; ");

			result.Append(Environment.NewLine);
		}

		conn.Close();

		// output the result
		resultTextBox.Text = result.ToString();
	}
}