using System;
using System.Configuration;
using System.Text;

using System.Data;
using System.Data.SqlClient;

public class TypedDataSetNullsForm : System.Windows.Forms.Form
{
	// table name constants
	private const String CATEGORIES_TABLE	= "Categories";

	private System.Windows.Forms.Button goButton;
	private System.Windows.Forms.RadioButton defaultRadioButton;
	private System.Windows.Forms.RadioButton annotatedRadioButton;
	private System.Windows.Forms.TextBox resultTextBox;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public TypedDataSetNullsForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.goButton = new System.Windows.Forms.Button();
		this.defaultRadioButton = new System.Windows.Forms.RadioButton();
		this.annotatedRadioButton = new System.Windows.Forms.RadioButton();
		this.resultTextBox = new System.Windows.Forms.TextBox();
		this.SuspendLayout();
		// 
		// goButton
		// 
		this.goButton.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
		this.goButton.Location = new System.Drawing.Point(408, 8);
		this.goButton.Name = "goButton";
		this.goButton.TabIndex = 2;
		this.goButton.Text = "Go";
		this.goButton.Click += new System.EventHandler(this.goButton_Click);
		// 
		// defaultRadioButton
		// 
		this.defaultRadioButton.Checked = true;
		this.defaultRadioButton.Location = new System.Drawing.Point(8, 8);
		this.defaultRadioButton.Name = "defaultRadioButton";
		this.defaultRadioButton.Size = new System.Drawing.Size(64, 24);
		this.defaultRadioButton.TabIndex = 0;
		this.defaultRadioButton.TabStop = true;
		this.defaultRadioButton.Text = "Default";
		// 
		// annotatedRadioButton
		// 
		this.annotatedRadioButton.Location = new System.Drawing.Point(80, 8);
		this.annotatedRadioButton.Name = "annotatedRadioButton";
		this.annotatedRadioButton.Size = new System.Drawing.Size(88, 24);
		this.annotatedRadioButton.TabIndex = 1;
		this.annotatedRadioButton.Text = "Annotated";
		// 
		// resultTextBox
		// 
		this.resultTextBox.Location = new System.Drawing.Point(8, 40);
		this.resultTextBox.Multiline = true;
		this.resultTextBox.Name = "resultTextBox";
		this.resultTextBox.ReadOnly = true;
		this.resultTextBox.Size = new System.Drawing.Size(476, 216);
		this.resultTextBox.TabIndex = 3;
		this.resultTextBox.Text = "";
		// 
		// TypedDataSetNullsForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(492, 266);
		this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		this.resultTextBox,
																		this.annotatedRadioButton,
																		this.defaultRadioButton,
																		this.goButton});
		this.Name = "TypedDataSetNullsForm";
		this.Text = "2.19 TypedDataSetNullsForm";
		this.ResumeLayout(false);

	}
	#endregion

	private void goButton_Click(object sender, System.EventArgs e)
	{
		StringBuilder result = new StringBuilder();

		// create the DataAdapter
		SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM Categories", ConfigurationSettings.AppSettings["Sql_ConnectString"]);

		if (annotatedRadioButton.Checked)
		{
			// create the typed DataSet without null annotation
			CategoriesDS_AnnotatedNull ds = new CategoriesDS_AnnotatedNull();
			// fill the Categories table within DataSet
			da.Fill(ds, CATEGORIES_TABLE);

			// add a row with a null Description
			ds.Categories.AddCategoriesRow("New Category", null);

			result.Append("Annotated Nulls" + Environment.NewLine + Environment.NewLine);
			// iterate over the rows collection and display columns
			foreach(CategoriesDS_AnnotatedNull.CategoriesRow row in ds.Categories)
			{
				// get the Description
				String description = row.Description;

				// note that the null Description is replaced
				result.Append(row.CategoryID + "\t" + row.CategoryName + "\t" + description + Environment.NewLine);
			}
		}
		else
		{
			// create the typed DataSet annotated for nulls
			CategoriesDS ds = new CategoriesDS();
			da.Fill(ds, CATEGORIES_TABLE);

			// add a row with a null Description
			ds.Categories.AddCategoriesRow("New Category", null);

			result.Append("Default" + Environment.NewLine + Environment.NewLine);
			// iterate over the rows collection and display columns
			foreach(CategoriesDS.CategoriesRow row in ds.Categories)
			{
				// use Is<field>Null method or StrongTypingException will
				// result when null row.Description is accessed
				String description = row.IsDescriptionNull() ? "NULL" : row.Description;

				// not that the null Description is not replaced
				result.Append(row.CategoryID + "\t" + row.CategoryName + "\t" + description + Environment.NewLine);
			}
		}

		resultTextBox.Text = result.ToString();
	}
}