using System;

using System.Data;
using System.Data.SqlClient;

public class AddParentChildAutoIncrementForm : System.Windows.Forms.Form
{
	// table name constants
	private const String PARENTTABLENAME	= "ParentTable";
	private const String CHILDTABLENAME		= "ChildTable";

	// table column name constants for Parent table
	private const String PARENTID_FIELD		= "ParentId";
	private const String FIELD1_FIELD		= "Field1";
	private const String FIELD2_FIELD		= "Field2";

	// table column parameter name constants for Parent table
	private const String CHILDID_FIELD		= "ChildId";
	private const String FIELD3_FIELD		= "Field3";
	private const String FIELD4_FIELD		= "Field4";

	private DataSet ds;

	private System.Windows.Forms.DataGrid dataGrid;
	private System.Windows.Forms.Button addRecordButton;

	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public AddParentChildAutoIncrementForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.addRecordButton = new System.Windows.Forms.Button();
		this.dataGrid = new System.Windows.Forms.DataGrid();
		((System.ComponentModel.ISupportInitialize)(this.dataGrid)).BeginInit();
		this.SuspendLayout();
		// 
		// addRecordButton
		// 
		this.addRecordButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
		this.addRecordButton.Location = new System.Drawing.Point(408, 232);
		this.addRecordButton.Name = "addRecordButton";
		this.addRecordButton.TabIndex = 0;
		this.addRecordButton.Text = "Add Record";
		this.addRecordButton.Click += new System.EventHandler(this.addRecordButton_Click);
		// 
		// dataGrid
		// 
		this.dataGrid.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
			| System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right);
		this.dataGrid.DataMember = "";
		this.dataGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
		this.dataGrid.Location = new System.Drawing.Point(8, 8);
		this.dataGrid.Name = "dataGrid";
		this.dataGrid.ReadOnly = true;
		this.dataGrid.Size = new System.Drawing.Size(476, 216);
		this.dataGrid.TabIndex = 1;
		// 
		// AddParentChildAutoIncrementForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(492, 266);
		this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		this.dataGrid,
																		this.addRecordButton});
		this.Name = "AddParentChildAutoIncrementForm";
		this.Text = "4.05 AddParentChildAutoIncrementForm";
		this.Load += new System.EventHandler(this.AddParentChildAutoIncrementForm_Load);
		((System.ComponentModel.ISupportInitialize)(this.dataGrid)).EndInit();
		this.ResumeLayout(false);

	}
	#endregion

	private void AddParentChildAutoIncrementForm_Load(object sender, System.EventArgs e)
	{
		DataColumnCollection cols;
		DataColumn col;

		// build the parent table
		DataTable parentTable = new DataTable(PARENTTABLENAME);
		cols = parentTable.Columns;
		col = cols.Add(PARENTID_FIELD, typeof(Int32));
		col.AutoIncrement = true;
		col.AutoIncrementSeed = -1;
		col.AutoIncrementStep = -1;
		cols.Add(FIELD1_FIELD, typeof(String)).MaxLength = 50;
		cols.Add(FIELD2_FIELD, typeof(String)).MaxLength = 50;

		// build the child table
		DataTable childTable = new DataTable(CHILDTABLENAME);
		cols = childTable.Columns;
		col = cols.Add(CHILDID_FIELD, typeof(Int32));
		col.AutoIncrement = true;
		col.AutoIncrementSeed = -1;
		col.AutoIncrementStep = -1;
		cols.Add(PARENTID_FIELD, typeof(Int32)).AllowDBNull = false;
		cols.Add(FIELD3_FIELD, typeof(String)).MaxLength = 50;
		cols.Add(FIELD4_FIELD, typeof(String)).MaxLength = 50;

		// add the tables to the DataSet and create the relationship between them
		ds = new DataSet();
		ds.Tables.Add(parentTable);
		ds.Tables.Add(childTable);
		ds.Relations.Add(new DataRelation("Parent_Child_Relation",
			parentTable.Columns[PARENTID_FIELD], childTable.Columns[PARENTID_FIELD], true));			

		// bind the parent table default view to the grid
		dataGrid.DataSource = parentTable.DefaultView;
	}

	private void addRecordButton_Click(object sender, System.EventArgs e)
	{
		// add a record to the parent table
		DataRow parentRow = ds.Tables[PARENTTABLENAME].NewRow();
		parentRow[FIELD1_FIELD] = Guid.NewGuid().ToString();
		parentRow[FIELD2_FIELD] = Guid.NewGuid().ToString();
		ds.Tables[PARENTTABLENAME].Rows.Add(parentRow);

		// add some child records for the parent
		for(int i = 0; i <= new Random((int)DateTime.Now.Ticks).Next(5); i++)
		{
			ds.Tables[CHILDTABLENAME].Rows.Add(new object[]
				{null, (int)parentRow[PARENTID_FIELD], Guid.NewGuid().ToString(), Guid.NewGuid().ToString()});
		}
	}
}