using System;
using System.Configuration;
using System.Windows.Forms;

using System.Data;
using System.Data.SqlClient;

public class UpdateManyToManyRelationshipForm : System.Windows.Forms.Form
{
	private DataSet ds;
	private SqlDataAdapter daParent, daParentChild, daChild;

	private const String PARENTTABLENAME		= "TBL0410Parent";
	private const String PARENTCHILDTABLENAME	= "TBL0410ParentChild";
	private const String CHILDTABLENAME			= "TBL0410Child";

	// table column name constants for Parent table
	private const String PARENTID_FIELD			= "ParentId";
	private const String FIELD1_FIELD			= "Field1";
	private const String FIELD2_FIELD			= "Field2";

	// table column parameter name constants for Child table
	private const String CHILDID_FIELD			= "ChildId";
	private const String FIELD3_FIELD			= "Field3";
	private const String FIELD4_FIELD			= "Field4";

	// stored procedure name constants
	private const String DELETEPARENT_SP		= "SP0410_DeleteParent";
	private const String GETPARENT_SP			= "SP0410_GetParent";
	private const String INSERTPARENT_SP		= "SP0410_InsertParent";
	private const String UPDATEPARENT_SP		= "SP0410_UpdateParent";
	private const String DELETEPARENTCHILD_SP	= "SP0410_DeleteParentChild";
	private const String GETPARENTCHILD_SP		= "SP0410_GetParentChild";
	private const String INSERTPARENTCHILD_SP	= "SP0410_InsertParentChild";
	private const String DELETECHILD_SP			= "SP0410_DeleteChild";
	private const String GETCHILD_SP			= "SP0410_GetChild";
	private const String INSERTCHILD_SP			= "SP0410_InsertChild";
	private const String UPDATECHILD_SP			= "SP0410_UpdateChild";

	// stored procedure parameter name constants for Parent table
	private const String PARENTID_PARM			= "@ParentId";
	private const String FIELD1_PARM			= "@Field1";
	private const String FIELD2_PARM			= "@Field2";

	// stored procedure parameter name constants for Child table
	private const String CHILDID_PARM			= "@ChildId";
	private const String FIELD3_PARM			= "@Field3";
	private const String FIELD4_PARM			= "@Field4";

	private System.Windows.Forms.DataGrid dataGridParent;
	private System.Windows.Forms.DataGrid dataGridChild;
	private System.Windows.Forms.Button createDataButton;
	private System.Windows.Forms.Button deleteButton;
	private System.Windows.Forms.Button modifyButton;
	private System.Windows.Forms.Button refreshButton;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public UpdateManyToManyRelationshipForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.dataGridParent = new System.Windows.Forms.DataGrid();
		this.dataGridChild = new System.Windows.Forms.DataGrid();
		this.createDataButton = new System.Windows.Forms.Button();
		this.deleteButton = new System.Windows.Forms.Button();
		this.modifyButton = new System.Windows.Forms.Button();
		this.refreshButton = new System.Windows.Forms.Button();
		((System.ComponentModel.ISupportInitialize)(this.dataGridParent)).BeginInit();
		((System.ComponentModel.ISupportInitialize)(this.dataGridChild)).BeginInit();
		this.SuspendLayout();
		// 
		// dataGridParent
		// 
		this.dataGridParent.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right);
		this.dataGridParent.CaptionText = "Parent";
		this.dataGridParent.DataMember = "";
		this.dataGridParent.HeaderForeColor = System.Drawing.SystemColors.ControlText;
		this.dataGridParent.Location = new System.Drawing.Point(8, 8);
		this.dataGridParent.Name = "dataGridParent";
		this.dataGridParent.ReadOnly = true;
		this.dataGridParent.Size = new System.Drawing.Size(480, 200);
		this.dataGridParent.TabIndex = 0;
		// 
		// dataGridChild
		// 
		this.dataGridChild.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right);
		this.dataGridChild.CaptionText = "Child";
		this.dataGridChild.DataMember = "";
		this.dataGridChild.HeaderForeColor = System.Drawing.SystemColors.ControlText;
		this.dataGridChild.Location = new System.Drawing.Point(8, 224);
		this.dataGridChild.Name = "dataGridChild";
		this.dataGridChild.ReadOnly = true;
		this.dataGridChild.Size = new System.Drawing.Size(480, 200);
		this.dataGridChild.TabIndex = 1;
		// 
		// createDataButton
		// 
		this.createDataButton.Location = new System.Drawing.Point(8, 432);
		this.createDataButton.Name = "createDataButton";
		this.createDataButton.TabIndex = 2;
		this.createDataButton.Text = "Create Data";
		this.createDataButton.Click += new System.EventHandler(this.createDataButton_Click);
		// 
		// deleteButton
		// 
		this.deleteButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
		this.deleteButton.Location = new System.Drawing.Point(168, 432);
		this.deleteButton.Name = "deleteButton";
		this.deleteButton.TabIndex = 4;
		this.deleteButton.Text = "Delete Data";
		this.deleteButton.Click += new System.EventHandler(this.deleteButton_Click);
		// 
		// modifyButton
		// 
		this.modifyButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
		this.modifyButton.Location = new System.Drawing.Point(88, 432);
		this.modifyButton.Name = "modifyButton";
		this.modifyButton.TabIndex = 3;
		this.modifyButton.Text = "Modify Data";
		this.modifyButton.Click += new System.EventHandler(this.modifyButton_Click);
		// 
		// refreshButton
		// 
		this.refreshButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
		this.refreshButton.Location = new System.Drawing.Point(248, 432);
		this.refreshButton.Name = "refreshButton";
		this.refreshButton.TabIndex = 5;
		this.refreshButton.Text = "Refresh";
		this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
		// 
		// UpdateManyToManyRelationshipForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(492, 466);
		this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		this.refreshButton,
																		this.modifyButton,
																		this.deleteButton,
																		this.createDataButton,
																		this.dataGridChild,
																		this.dataGridParent});
		this.Name = "UpdateManyToManyRelationshipForm";
		this.Text = "4.10 UpdateManyToManyRelationshipForm";
		this.Load += new System.EventHandler(this.UpdateManyToManyRelationshipForm_Load);
		((System.ComponentModel.ISupportInitialize)(this.dataGridParent)).EndInit();
		((System.ComponentModel.ISupportInitialize)(this.dataGridChild)).EndInit();
		this.ResumeLayout(false);

	}
	#endregion

	private void UpdateManyToManyRelationshipForm_Load(object sender, System.EventArgs e)
	{
		DataColumnCollection cols;
		DataColumn col;

		// build the parent table
		DataTable parentTable = new DataTable(PARENTTABLENAME);
		cols = parentTable.Columns;
		col = cols.Add(PARENTID_FIELD, typeof(Int32));
		col.AutoIncrement = true;
		col.AutoIncrementSeed = -1;
		col.AutoIncrementStep = -1;
		cols.Add(FIELD1_FIELD, typeof(String)).MaxLength = 50;
		cols.Add(FIELD2_FIELD, typeof(String)).MaxLength = 50;

		// build the ParentChild table
		DataTable parentChildTable = new DataTable(PARENTCHILDTABLENAME);
		cols = parentChildTable.Columns;
		cols.Add(PARENTID_FIELD, typeof(Int32)).AllowDBNull = false;
		cols.Add(CHILDID_FIELD, typeof(Int32)).AllowDBNull = false;
		parentChildTable.PrimaryKey = new DataColumn[]
			{cols[PARENTID_FIELD], cols[CHILDID_FIELD]};

		// build the child table
		DataTable childTable = new DataTable(CHILDTABLENAME);
		cols = childTable.Columns;
		col = cols.Add(CHILDID_FIELD, typeof(Int32));
		col.AutoIncrement = true;
		col.AutoIncrementSeed = -1;
		col.AutoIncrementStep = -1;
		cols.Add(FIELD3_FIELD, typeof(String)).MaxLength = 50;
		cols.Add(FIELD4_FIELD, typeof(String)).MaxLength = 50;

		// add the tables to the DataSet and create the relationship between them
		ds = new DataSet();
		ds.Tables.Add(parentTable);
		ds.Tables.Add(parentChildTable);
		ds.Tables.Add(childTable);
		ds.Relations.Add(new DataRelation("Parent_ParentChild",
			parentTable.Columns[PARENTID_FIELD], parentChildTable.Columns[PARENTID_FIELD], true));
		ds.Relations.Add(new DataRelation("Child_ParentChild",
			childTable.Columns[CHILDID_FIELD], parentChildTable.Columns[CHILDID_FIELD], true));


		// create the Parent DataAdapter
		daParent = new SqlDataAdapter(GETPARENT_SP, ConfigurationSettings.AppSettings["Sql_ConnectString"]);
		daParent.SelectCommand.CommandType = CommandType.StoredProcedure;

		// build the parent delete command
		SqlCommand deleteCommand = new SqlCommand(DELETEPARENT_SP, daParent.SelectCommand.Connection);
		deleteCommand.CommandType = CommandType.StoredProcedure;
		deleteCommand.Parameters.Add(PARENTID_PARM, SqlDbType.Int, 0, PARENTID_FIELD);
		daParent.DeleteCommand = deleteCommand;

		// build the parent insert command
		SqlCommand insertCommand = new SqlCommand(INSERTPARENT_SP, daParent.SelectCommand.Connection);
		insertCommand.CommandType = CommandType.StoredProcedure;
		insertCommand.Parameters.Add(PARENTID_PARM, SqlDbType.Int, 0, PARENTID_FIELD);
		insertCommand.Parameters.Add(FIELD1_PARM, SqlDbType.NVarChar, 50, FIELD1_FIELD);
		insertCommand.Parameters.Add(FIELD2_PARM, SqlDbType.NVarChar, 50, FIELD2_FIELD);
		daParent.InsertCommand = insertCommand;

		// build the parent update command
		SqlCommand updateCommand = new SqlCommand(UPDATEPARENT_SP, daParent.SelectCommand.Connection);
		updateCommand.CommandType = CommandType.StoredProcedure;
		updateCommand.Parameters.Add(PARENTID_PARM, SqlDbType.Int, 0, PARENTID_FIELD);
		updateCommand.Parameters.Add(FIELD1_PARM, SqlDbType.NVarChar, 50, FIELD1_FIELD);
		updateCommand.Parameters.Add(FIELD2_PARM, SqlDbType.NVarChar, 50, FIELD2_FIELD);
		daParent.UpdateCommand = updateCommand;


		// Create the Child DataAdapter
		daChild = new SqlDataAdapter(GETCHILD_SP, ConfigurationSettings.AppSettings["Sql_ConnectString"]);
		daChild.SelectCommand.CommandType = CommandType.StoredProcedure;

		// build the child delete command
		deleteCommand = new SqlCommand(DELETECHILD_SP, daChild.SelectCommand.Connection);
		deleteCommand.CommandType = CommandType.StoredProcedure;
		deleteCommand.Parameters.Add(CHILDID_PARM, SqlDbType.Int, 0, CHILDID_FIELD);
		daChild.DeleteCommand = deleteCommand;

		// build the child insert command
		insertCommand = new SqlCommand(INSERTCHILD_SP, daChild.SelectCommand.Connection);
		insertCommand.CommandType = CommandType.StoredProcedure;
		insertCommand.Parameters.Add(CHILDID_PARM, SqlDbType.Int, 0, CHILDID_FIELD);
		insertCommand.Parameters.Add(FIELD3_PARM, SqlDbType.NVarChar, 50, FIELD3_FIELD);
		insertCommand.Parameters.Add(FIELD4_PARM, SqlDbType.NVarChar, 50, FIELD4_FIELD);
		daChild.InsertCommand = insertCommand;

		// build the child update command
		updateCommand = new SqlCommand(UPDATECHILD_SP, daChild.SelectCommand.Connection);
		updateCommand.CommandType = CommandType.StoredProcedure;
		updateCommand.Parameters.Add(CHILDID_PARM, SqlDbType.Int, 0, CHILDID_FIELD);
		updateCommand.Parameters.Add(FIELD3_PARM, SqlDbType.NVarChar, 50, FIELD3_FIELD);
		updateCommand.Parameters.Add(FIELD4_PARM, SqlDbType.NVarChar, 50, FIELD4_FIELD);
		daChild.UpdateCommand = updateCommand;

		
		// Create the ParentChild DataAdapter
		daParentChild = new SqlDataAdapter(GETPARENTCHILD_SP, ConfigurationSettings.AppSettings["Sql_ConnectString"]);
		daParentChild.SelectCommand.CommandType = CommandType.StoredProcedure;

		// build the ParentChild delete command
		deleteCommand = new SqlCommand(DELETEPARENTCHILD_SP, daParentChild.SelectCommand.Connection);
		deleteCommand.CommandType = CommandType.StoredProcedure;
		deleteCommand.Parameters.Add(PARENTID_PARM, SqlDbType.Int, 0, PARENTID_FIELD);
		deleteCommand.Parameters.Add(CHILDID_PARM, SqlDbType.Int, 0, CHILDID_FIELD);
		daParentChild.DeleteCommand = deleteCommand;

		// build the ParentChild insert command
		insertCommand = new SqlCommand(INSERTPARENTCHILD_SP, daParentChild.SelectCommand.Connection);
		insertCommand.CommandType = CommandType.StoredProcedure;
		insertCommand.Parameters.Add(PARENTID_PARM, SqlDbType.Int, 0, PARENTID_FIELD);
		insertCommand.Parameters.Add(CHILDID_PARM, SqlDbType.Int, 0, CHILDID_FIELD);
		daParentChild.InsertCommand = insertCommand;

		LoadData();

		dataGridParent.DataSource = parentTable.DefaultView;
		dataGridChild.DataSource = childTable.DefaultView;
	}

	private void LoadData()
	{
		// fill the dataset
		daParent.Fill(ds, PARENTTABLENAME);
		daChild.Fill(ds, CHILDTABLENAME);
		daParentChild.Fill(ds, PARENTCHILDTABLENAME);
	}

	private void CreateData(int parentRows, int childRows)
	{
		// create some data update the data source with it.
		for(int iParent = 0; iParent < parentRows; iParent++)
		{
			DataRow parentRow = ds.Tables[PARENTTABLENAME].NewRow();
			parentRow[FIELD1_FIELD] = Guid.NewGuid().ToString();
			parentRow[FIELD2_FIELD] = Guid.NewGuid().ToString();
			ds.Tables[PARENTTABLENAME].Rows.Add(parentRow);
		}

		for(int iChild = 0; iChild < childRows; iChild++)
		{
			DataRow childRow = ds.Tables[CHILDTABLENAME].NewRow();
			childRow[FIELD3_FIELD] = Guid.NewGuid().ToString();
			childRow[FIELD4_FIELD] = Guid.NewGuid().ToString();
			ds.Tables[CHILDTABLENAME].Rows.Add(childRow);
		}

		// randomly create the parent-child relationships
		Random r = new Random((int)DateTime.Now.Ticks);
		foreach(DataRow rowParent in ds.Tables[PARENTTABLENAME].Rows)
		{
			if(rowParent.RowState != DataRowState.Deleted)
			{
				foreach(DataRow rowChild in ds.Tables[CHILDTABLENAME].Rows)
				{
					if(rowChild.RowState != DataRowState.Deleted && r.Next(2) == 1)
					{
						// check to see that row doesn't exist before adding
						if(ds.Tables[PARENTCHILDTABLENAME].Rows.Find(new object[]
							{rowParent[PARENTID_FIELD], rowChild[CHILDID_FIELD]}) == null)
						{
							ds.Tables[PARENTCHILDTABLENAME].Rows.Add(new object[]
								{rowParent[PARENTID_FIELD], rowChild[CHILDID_FIELD]});
						}
					}
				}
			}
		}
	}

	private void UpdateData()
	{
		try
		{
			daParentChild.Update(ds.Tables[PARENTCHILDTABLENAME].Select(null, null, DataViewRowState.Deleted));
			daChild.Update(ds.Tables[CHILDTABLENAME].Select(null, null, DataViewRowState.Deleted));
			daParent.Update(ds.Tables[PARENTTABLENAME].Select(null, null, DataViewRowState.Deleted));
			daParent.Update(ds.Tables[PARENTTABLENAME].Select(null, null, DataViewRowState.ModifiedCurrent));
			daParent.Update(ds.Tables[PARENTTABLENAME].Select(null, null, DataViewRowState.Added));
			daChild.Update(ds.Tables[CHILDTABLENAME].Select(null, null, DataViewRowState.ModifiedCurrent));
			daChild.Update(ds.Tables[CHILDTABLENAME].Select(null, null, DataViewRowState.Added));
			daParentChild.Update(ds.Tables[PARENTCHILDTABLENAME].Select(null, null, DataViewRowState.Added));
		}
		catch (Exception ex)
		{
			MessageBox.Show(ex.Message);
		}
	}

	private void createDataButton_Click(object sender, System.EventArgs e)
	{
		// create parent and child records
		CreateData(4,4);

		UpdateData();
		MessageBox.Show("Data created.","Many-to-Many Relationships", MessageBoxButtons.OK, MessageBoxIcon.Information);
	}

	private void modifyButton_Click(object sender, System.EventArgs e)
	{
		Random r = new Random((int)DateTime.Now.Ticks);

		// randomly delete or modify rows from the child and parent rows
		for(int i = ds.Tables[CHILDTABLENAME].Rows.Count; i > 0; i--)
		{
			DataRow childRow = ds.Tables[CHILDTABLENAME].Rows[i - 1];

			if(r.Next(2) == 0)
			{
				childRow[FIELD3_FIELD] = Guid.NewGuid().ToString();
				childRow[FIELD4_FIELD] = Guid.NewGuid().ToString();
			}
			else
				childRow.Delete();
		}

		for(int i = ds.Tables[PARENTTABLENAME].Rows.Count; i > 0; i--)
		{
			DataRow parentRow = ds.Tables[PARENTTABLENAME].Rows[i - 1];

			if(r.Next(2) == 0)
			{
				parentRow[FIELD1_FIELD] = Guid.NewGuid().ToString();
				parentRow[FIELD2_FIELD] = Guid.NewGuid().ToString();
			}
			else
				parentRow.Delete();
				
		}

		// randomly delete m-n parentchild relationships
		for(int i = ds.Tables[PARENTCHILDTABLENAME].Rows.Count; i > 0; i--)
		{
			DataRow parentChildRow = ds.Tables[PARENTCHILDTABLENAME].Rows[i - 1];

			if(r.Next(2) == 0)
				parentChildRow.Delete();					
		}
	
		// insert two rows into Parent, Child and random ParentChild
		CreateData(2,2);

		UpdateData();

		MessageBox.Show("Data randomly modified.", "Many-to-Many Relationships", MessageBoxButtons.OK, MessageBoxIcon.Information);		
	}

	private void deleteButton_Click(object sender, System.EventArgs e)
	{
		// delete the Parent records
		for(int i = ds.Tables[PARENTTABLENAME].Rows.Count; i > 0 ;i--)
			ds.Tables[PARENTTABLENAME].Rows[i - 1].Delete();

		// delete the Child records
		for(int i = ds.Tables[CHILDTABLENAME].Rows.Count; i > 0; i--)
			ds.Tables[CHILDTABLENAME].Rows[i - 1].Delete();

		// delete the ParentChild records
		for(int i = ds.Tables[PARENTCHILDTABLENAME].Rows.Count; i > 0 ;i--)
			ds.Tables[PARENTCHILDTABLENAME].Rows[i - 1].Delete();

		UpdateData();

		MessageBox.Show("Data deleted.", "Many-to-Many Relationships", MessageBoxButtons.OK, MessageBoxIcon.Information);
	}

	private void refreshButton_Click(object sender, System.EventArgs e)
	{
		ds.Clear();

		LoadData();
	}
}