using System;
using System.Configuration;
using System.Text;

using System.Data;
using System.Data.SqlClient;

public class AdoGetStringForm : System.Windows.Forms.Form
{
	// table name constants
	private const String ORDERS_TABLE		= "Orders";

	private System.Windows.Forms.Button goButton;
	private System.Windows.Forms.TextBox resultTextBox;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public AdoGetStringForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.goButton = new System.Windows.Forms.Button();
		this.resultTextBox = new System.Windows.Forms.TextBox();
		this.SuspendLayout();
		// 
		// goButton
		// 
		this.goButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
		this.goButton.Location = new System.Drawing.Point(408, 232);
		this.goButton.Name = "goButton";
		this.goButton.TabIndex = 0;
		this.goButton.Text = "Go";
		this.goButton.Click += new System.EventHandler(this.goButton_Click);
		// 
		// resultTextBox
		// 
		this.resultTextBox.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
			| System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right);
		this.resultTextBox.Location = new System.Drawing.Point(8, 8);
		this.resultTextBox.Multiline = true;
		this.resultTextBox.Name = "resultTextBox";
		this.resultTextBox.ReadOnly = true;
		this.resultTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
		this.resultTextBox.Size = new System.Drawing.Size(476, 216);
		this.resultTextBox.TabIndex = 1;
		this.resultTextBox.Text = "";
		// 
		// AdoGetStringForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(492, 266);
		this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		this.resultTextBox,
																		this.goButton});
		this.Name = "AdoGetStringForm";
		this.Text = "5.11 AdoGetStringForm";
		this.ResumeLayout(false);

	}
	#endregion

	private void goButton_Click(object sender, System.EventArgs e)
	{
		// fill the Order table
		SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM Orders", ConfigurationSettings.AppSettings["Sql_ConnectString"]);
		DataTable dt = new DataTable(ORDERS_TABLE);
		da.Fill(dt);

		// call method to convert the DataTable to a string
		resultTextBox.Text = GetString(dt, -1, null, null, null);
	}

	private String GetString(DataTable dt, int numRows, String columnDelimiter, String rowDelimiter, String nullExpr)
	{
		if(numRows < 0)
			// negative number of rows returns all rows
			numRows = dt.Rows.Count;
		else
			// set number of rows to the lesser of the user entered
			// number of rows and the number of rows in the table
			numRows = Math.Max(numRows, dt.Rows.Count);

		// column delimiter defaults to TAB
		if(columnDelimiter == null)
			columnDelimiter = "\t";

		// row delimiter defaults to CARRIAGE RETURN
		if(rowDelimiter == null)
			rowDelimiter = "\r";

		// null expression defaults to empty string
		if(nullExpr == null)
			nullExpr = "";

		StringBuilder sb = new StringBuilder();

		// iterate over the collection of rows
		for(int i = 0; i < numRows; i++)
		{
			// iterate over the collection of columns
			foreach (object col in dt.Rows[i].ItemArray)
			{	
				// replace null values as they occur
				String colString = (col == System.DBNull.Value) ? nullExpr : col.ToString();

				// add the column value to the string
				sb.Append(colString + columnDelimiter);
			}
			// remove the column delimiter on last field
			sb.Remove(sb.Length - columnDelimiter.Length, columnDelimiter.Length);
			// append row delimiter
			sb.Append(rowDelimiter);
		}

		return sb.ToString();
	}
}