<?xml version="1.0" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:rs="urn:schemas-microsoft-com:rowset"
	xmlns:z="#RowsetSchema"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:wxh="http://element14.com/wxhnamespace"
	version="1.0"
>
<msxsl:script language="CSharp" implements-prefix="wxh">
	<![CDATA[
	private String GetShortTime(String longDateTime)
	{
		return longDateTime.Substring(0,19);
	}
	]]>
</msxsl:script>

	<xsl:output method="xml" indent="yes" />
	<xsl:template match="NewDataSet">
		<rs:data>
			<xsl:apply-templates select="Orders" />
		</rs:data>
	</xsl:template>
	<xsl:template match="Orders">
		<z:row>
			<xsl:apply-templates select="@OrderID" />
			<xsl:apply-templates select="@CustomerID" />
			<xsl:apply-templates select="@EmployeeID" />
			<xsl:apply-templates select="@OrderDate" />
			<xsl:apply-templates select="@RequiredDate" />
			<xsl:apply-templates select="@ShippedDate" />
			<xsl:apply-templates select="@ShipVia" />
			<xsl:apply-templates select="@Freight" />
			<xsl:apply-templates select="@ShipName" />
			<xsl:apply-templates select="@ShipAddress" />
			<xsl:apply-templates select="@ShipCity" />
			<xsl:apply-templates select="@ShipRegion" />
			<xsl:apply-templates select="@ShipPostalCode" />
			<xsl:apply-templates select="@ShipCountry" />
		</z:row>
	</xsl:template>
	<xsl:template match="@OrderDate">
		<xsl:attribute name="OrderDate">
			<xsl:value-of select="wxh:GetShortTime(.)" />
		</xsl:attribute>
	</xsl:template>
	<xsl:template match="@RequiredDate">
		<xsl:attribute name="RequiredDate">
			<xsl:value-of select="wxh:GetShortTime(.)" />
		</xsl:attribute>
	</xsl:template>
	<xsl:template match="@ShippedDate">
		<xsl:attribute name="ShippedDate">
			<xsl:value-of select="wxh:GetShortTime(.)" />
		</xsl:attribute>
	</xsl:template>
	<xsl:template match="@*">
		<xsl:copy-of select="." />
	</xsl:template>
</xsl:stylesheet>