using System;
using System.Configuration;
using System.Windows.Forms;

using System.IO;
using System.Data;
using System.Data.SqlClient;

using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters.Soap;	// Requires reference to System.Runtime.Serialization.Formatters.Soap
using System.Xml.Serialization;

public class SerializeForm : System.Windows.Forms.Form
{
	// table name constants
	private const String ORDERS_TABLE		= "Orders";
	private const String ORDERDETAILS_TABLE	= "OrderDetails";

	// relation name constants
	private const String ORDERS_ORDERDETAILS_RELATION = "Orders_OrderDetails_Relation";

	// field name constants
	private const String ORDERID_FIELD		= "OrderID";

	private SaveFileDialog sfd;
	private System.Windows.Forms.RadioButton soapRadioButton;
	private System.Windows.Forms.RadioButton binaryRadioButton;
	private System.Windows.Forms.Button goButton;
	private System.Windows.Forms.Button fileDialogButton;
	private System.Windows.Forms.TextBox fileNameTextBox;
	private System.Windows.Forms.Label label1;
	private System.Windows.Forms.RadioButton xmlWriteRadioButton;
	private System.Windows.Forms.RadioButton xmlSerializerRadioButton;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public SerializeForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		sfd=new SaveFileDialog();
		sfd.InitialDirectory=System.IO.Path.GetTempPath();
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.xmlSerializerRadioButton = new System.Windows.Forms.RadioButton();
		this.soapRadioButton = new System.Windows.Forms.RadioButton();
		this.binaryRadioButton = new System.Windows.Forms.RadioButton();
		this.goButton = new System.Windows.Forms.Button();
		this.fileNameTextBox = new System.Windows.Forms.TextBox();
		this.fileDialogButton = new System.Windows.Forms.Button();
		this.label1 = new System.Windows.Forms.Label();
		this.xmlWriteRadioButton = new System.Windows.Forms.RadioButton();
		this.SuspendLayout();
		// 
		// xmlSerializerRadioButton
		// 
		this.xmlSerializerRadioButton.Location = new System.Drawing.Point(8, 32);
		this.xmlSerializerRadioButton.Name = "xmlSerializerRadioButton";
		this.xmlSerializerRadioButton.TabIndex = 1;
		this.xmlSerializerRadioButton.Text = "XmlSerializer";
		// 
		// soapRadioButton
		// 
		this.soapRadioButton.Location = new System.Drawing.Point(8, 56);
		this.soapRadioButton.Name = "soapRadioButton";
		this.soapRadioButton.TabIndex = 2;
		this.soapRadioButton.Text = "SOAP";
		// 
		// binaryRadioButton
		// 
		this.binaryRadioButton.Location = new System.Drawing.Point(8, 80);
		this.binaryRadioButton.Name = "binaryRadioButton";
		this.binaryRadioButton.TabIndex = 3;
		this.binaryRadioButton.Text = "Binary";
		// 
		// goButton
		// 
		this.goButton.Location = new System.Drawing.Point(208, 8);
		this.goButton.Name = "goButton";
		this.goButton.TabIndex = 5;
		this.goButton.Text = "Go";
		this.goButton.Click += new System.EventHandler(this.goButton_Click);
		// 
		// fileNameTextBox
		// 
		this.fileNameTextBox.Location = new System.Drawing.Point(8, 136);
		this.fileNameTextBox.Name = "fileNameTextBox";
		this.fileNameTextBox.Size = new System.Drawing.Size(240, 20);
		this.fileNameTextBox.TabIndex = 4;
		this.fileNameTextBox.Text = "";
		// 
		// fileDialogButton
		// 
		this.fileDialogButton.Location = new System.Drawing.Point(256, 136);
		this.fileDialogButton.Name = "fileDialogButton";
		this.fileDialogButton.Size = new System.Drawing.Size(24, 23);
		this.fileDialogButton.TabIndex = 8;
		this.fileDialogButton.Text = "...";
		this.fileDialogButton.Click += new System.EventHandler(this.fileDialogButton_Click);
		// 
		// label1
		// 
		this.label1.Location = new System.Drawing.Point(8, 120);
		this.label1.Name = "label1";
		this.label1.Size = new System.Drawing.Size(100, 16);
		this.label1.TabIndex = 9;
		this.label1.Text = "Filename:";
		// 
		// xmlWriteRadioButton
		// 
		this.xmlWriteRadioButton.Checked = true;
		this.xmlWriteRadioButton.Location = new System.Drawing.Point(8, 8);
		this.xmlWriteRadioButton.Name = "xmlWriteRadioButton";
		this.xmlWriteRadioButton.TabIndex = 0;
		this.xmlWriteRadioButton.Text = "XmlWrite";
		// 
		// SerializeForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(292, 166);
		this.Controls.Add(this.xmlWriteRadioButton);
		this.Controls.Add(this.label1);
		this.Controls.Add(this.fileDialogButton);
		this.Controls.Add(this.fileNameTextBox);
		this.Controls.Add(this.goButton);
		this.Controls.Add(this.binaryRadioButton);
		this.Controls.Add(this.soapRadioButton);
		this.Controls.Add(this.xmlSerializerRadioButton);
		this.Name = "SerializeForm";
		this.Text = "5.04 SerializeForm";
		this.ResumeLayout(false);

	}
	#endregion

	private void goButton_Click(object sender, System.EventArgs e)
	{
		DataSet ds = new DataSet();
		
		SqlDataAdapter da;

		// fill the Order table and add it to the DataSet
		da = new SqlDataAdapter("SELECT * FROM Orders", ConfigurationSettings.AppSettings["Sql_ConnectString"]);
		DataTable orderTable = new DataTable(ORDERS_TABLE);
		da.FillSchema(orderTable, SchemaType.Source);
		da.Fill(orderTable);
		ds.Tables.Add(orderTable);

		// fill the OrderDetails table and add it to the DataSet
		da = new SqlDataAdapter("SELECT * FROM [Order Details]", ConfigurationSettings.AppSettings["Sql_ConnectString"]);
		DataTable orderDetailTable = new DataTable(ORDERDETAILS_TABLE);
		da.FillSchema(orderDetailTable, SchemaType.Source);
		da.Fill(orderDetailTable);
		ds.Tables.Add(orderDetailTable);

		// create a relation between the tables
		ds.Relations.Add(ORDERS_ORDERDETAILS_RELATION,
			ds.Tables[ORDERS_TABLE].Columns[ORDERID_FIELD],
			ds.Tables[ORDERDETAILS_TABLE].Columns[ORDERID_FIELD],
			true);

		// create and open the stream for serializing
		Stream stream = null;
		try
		{
			stream = File.Open(fileNameTextBox.Text, FileMode.Create, FileAccess.Write);
		}
		catch(Exception ex)
		{
			MessageBox.Show(ex.Message, "Serializing Data", MessageBoxButtons.OK, MessageBoxIcon.Error);
			return;
		}

		// serialize
		if (xmlWriteRadioButton.Checked)
		{
			ds.WriteXml(stream, XmlWriteMode.WriteSchema);
		}
		else if (xmlSerializerRadioButton.Checked)
		{
			XmlSerializer xs = new XmlSerializer(typeof(DataSet));
			xs.Serialize(stream, ds);
		}
		else if(soapRadioButton.Checked)
		{
			SoapFormatter sf = new SoapFormatter();
			sf.Serialize(stream, ds);
		}
		else if(binaryRadioButton.Checked)
		{
			BinaryFormatter bf = new BinaryFormatter();
			bf.Serialize(stream, ds);
		}

		stream.Close();

		MessageBox.Show("Serialization complete.", "Serializing Data", MessageBoxButtons.OK, MessageBoxIcon.Information);
	}

	private void fileDialogButton_Click(object sender, System.EventArgs e)
	{
		// file dialog to save file
		if(xmlWriteRadioButton.Checked || xmlSerializerRadioButton.Checked)
			sfd.Filter = "XML files (*.xml)|*.xml";
		else if(soapRadioButton.Checked)
			sfd.Filter = "SOAP files (*.soap)|*.soap";
		else if(binaryRadioButton.Checked)
			sfd.Filter = "Binary files (*.bin)|*.bin";

		sfd.Filter += "|All files (*.*)|*.*";
		sfd.FilterIndex = 0;

		if (sfd.ShowDialog() == DialogResult.OK)
			fileNameTextBox.Text = sfd.FileName;
	}
}