using System;
using System.Configuration;
using System.Windows.Forms;

using System.Data;
using System.Data.SqlClient;

public class CustomColumnsInDataGridForm : System.Windows.Forms.Form
{
	private SqlDataAdapter da;
	private DataTable dt;

	private System.Windows.Forms.DataGrid dataGrid;
	private System.Windows.Forms.Button updateButton;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public CustomColumnsInDataGridForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.dataGrid = new System.Windows.Forms.DataGrid();
		this.updateButton = new System.Windows.Forms.Button();
		((System.ComponentModel.ISupportInitialize)(this.dataGrid)).BeginInit();
		this.SuspendLayout();
		// 
		// dataGrid
		// 
		this.dataGrid.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
			| System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right)));
		this.dataGrid.DataMember = "";
		this.dataGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
		this.dataGrid.Location = new System.Drawing.Point(8, 8);
		this.dataGrid.Name = "dataGrid";
		this.dataGrid.Size = new System.Drawing.Size(476, 220);
		this.dataGrid.TabIndex = 0;
		// 
		// updateButton
		// 
		this.updateButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
		this.updateButton.Location = new System.Drawing.Point(408, 236);
		this.updateButton.Name = "updateButton";
		this.updateButton.TabIndex = 1;
		this.updateButton.Text = "Update";
		this.updateButton.Click += new System.EventHandler(this.updateButton_Click);
		// 
		// CustomColumnsInDataGridForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(492, 266);
		this.Controls.Add(this.updateButton);
		this.Controls.Add(this.dataGrid);
		this.Name = "CustomColumnsInDataGridForm";
		this.Text = "7.10 CustomColumnsInDataGridForm";
		this.Load += new System.EventHandler(this.CustomColumnsInDataGridForm_Load);
		((System.ComponentModel.ISupportInitialize)(this.dataGrid)).EndInit();
		this.ResumeLayout(false);

	}
	#endregion

	private void CustomColumnsInDataGridForm_Load(object sender, System.EventArgs e)
	{
		// create the DataAdapter
		String selectCommand = "SELECT ProductID, ProductName, Discontinued " +
			"FROM Products";
		da = new SqlDataAdapter(selectCommand, ConfigurationSettings.AppSettings["Sql_ConnectString"]);
		// use CommandBuilder to handle updates back to the data source
		SqlCommandBuilder cb = new SqlCommandBuilder(da);
		
		// retrieve the table schema
		dt = new DataTable("Products");
		da.FillSchema(dt, SchemaType.Source);
		// default the check box column to false
		dt.Columns["Discontinued"].DefaultValue = false;
		// fill the table
		da.Fill(dt);

		// define the table for the grid
		DataGridTableStyle ts = new DataGridTableStyle();
		ts.MappingName = "Products";

		// define and add the columns to the grid
		DataGridTextBoxColumn productIDCol = new DataGridTextBoxColumn();
		productIDCol.MappingName = "ProductID";
		productIDCol.HeaderText = "Product ID";
		productIDCol.ReadOnly = true;
		ts.GridColumnStyles.Add(productIDCol);

		DataGridTextBoxColumn productNameCol = new DataGridTextBoxColumn();
		productNameCol.MappingName = "ProductName";
		productNameCol.HeaderText = "Name";
		productNameCol.Width = 200;
		productNameCol.Alignment = HorizontalAlignment.Center;
		ts.GridColumnStyles.Add(productNameCol);

		DataGridBoolColumn discontinuedCol = new DataGridBoolColumn();
		discontinuedCol.MappingName = "Discontinued";
		discontinuedCol.HeaderText = "Discontinued";
		discontinuedCol.AllowNull = false;
		ts.GridColumnStyles.Add(discontinuedCol);

		dataGrid.TableStyles.Add(ts);

		// bind the default view of the table to the grid
		dataGrid.DataSource = dt.DefaultView;
	}

	private void updateButton_Click(object sender, System.EventArgs e)
	{
		// update the data using the DataAdapter
		da.Update(dt);
	}
}