using System;
using System.Configuration;
using System.Windows.Forms;
using System.Text;

using System.Xml;

using System.Data;
using System.Data.SqlClient;

public class XPathQueryForm : System.Windows.Forms.Form
{
	// table name constants
	private const String ORDERS_TABLE		= "Orders";
	private const String ORDERDETAILS_TABLE	= "OrderDetails";

	// relation name constants
	private const String ORDERS_ORDERDETAILS_RELATION = "Orders_OrderDetails_Relation";

	// field name constants
	private const String ORDERID_FIELD		= "OrderID";

	private DataSet ds;

	private System.Windows.Forms.Button goButton;
	private System.Windows.Forms.TextBox xPathQueryResultTextBox;
	private System.Windows.Forms.Label label1;
	private System.Windows.Forms.TextBox orderIdTextBox;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public XPathQueryForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.goButton = new System.Windows.Forms.Button();
		this.xPathQueryResultTextBox = new System.Windows.Forms.TextBox();
		this.label1 = new System.Windows.Forms.Label();
		this.orderIdTextBox = new System.Windows.Forms.TextBox();
		this.SuspendLayout();
		// 
		// goButton
		// 
		this.goButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
		this.goButton.Location = new System.Drawing.Point(408, 232);
		this.goButton.Name = "goButton";
		this.goButton.TabIndex = 1;
		this.goButton.Text = "Go";
		this.goButton.Click += new System.EventHandler(this.goButton_Click);
		// 
		// xPathQueryResultTextBox
		// 
		this.xPathQueryResultTextBox.AcceptsReturn = true;
		this.xPathQueryResultTextBox.AcceptsTab = true;
		this.xPathQueryResultTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
			| System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right)));
		this.xPathQueryResultTextBox.Location = new System.Drawing.Point(8, 40);
		this.xPathQueryResultTextBox.Multiline = true;
		this.xPathQueryResultTextBox.Name = "xPathQueryResultTextBox";
		this.xPathQueryResultTextBox.ReadOnly = true;
		this.xPathQueryResultTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
		this.xPathQueryResultTextBox.Size = new System.Drawing.Size(476, 184);
		this.xPathQueryResultTextBox.TabIndex = 1;
		this.xPathQueryResultTextBox.Text = "";
		// 
		// label1
		// 
		this.label1.Location = new System.Drawing.Point(8, 12);
		this.label1.Name = "label1";
		this.label1.Size = new System.Drawing.Size(56, 16);
		this.label1.TabIndex = 2;
		this.label1.Text = "Order ID:";
		// 
		// orderIdTextBox
		// 
		this.orderIdTextBox.Location = new System.Drawing.Point(72, 8);
		this.orderIdTextBox.Name = "orderIdTextBox";
		this.orderIdTextBox.TabIndex = 0;
		this.orderIdTextBox.Text = "";
		// 
		// XPathQueryForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(492, 266);
		this.Controls.Add(this.orderIdTextBox);
		this.Controls.Add(this.xPathQueryResultTextBox);
		this.Controls.Add(this.label1);
		this.Controls.Add(this.goButton);
		this.Name = "XPathQueryForm";
		this.Text = "8.06 XPathQueryForm";
		this.Load += new System.EventHandler(this.XPathQueryForm_Load);
		this.ResumeLayout(false);

	}
	#endregion

	private void XPathQueryForm_Load(object sender, System.EventArgs e)
	{
		ds = new DataSet("Orders_OrderDetails");	
		SqlDataAdapter da;

		// fill the Order table and add it to the DataSet
		da = new SqlDataAdapter("SELECT * FROM Orders", ConfigurationSettings.AppSettings["Sql_ConnectString"]);
		DataTable orderTable = new DataTable(ORDERS_TABLE);
		da.Fill(orderTable);
		ds.Tables.Add(orderTable);

		// fill the OrderDetails table and add it to the DataSet
		da = new SqlDataAdapter("SELECT * FROM [Order Details]", ConfigurationSettings.AppSettings["Sql_ConnectString"]);
		DataTable orderDetailTable = new DataTable(ORDERDETAILS_TABLE);
		da.Fill(orderDetailTable);
		ds.Tables.Add(orderDetailTable);

		// create a relation between the tables
		ds.Relations.Add(ORDERS_ORDERDETAILS_RELATION,
			ds.Tables[ORDERS_TABLE].Columns[ORDERID_FIELD],
			ds.Tables[ORDERDETAILS_TABLE].Columns[ORDERID_FIELD],
			true);

		ds.Relations[ORDERS_ORDERDETAILS_RELATION].Nested = true;
	}

	private void goButton_Click(object sender, System.EventArgs e)
	{
		int orderId = 0;
		// get the user entered Order ID
		try
		{
			orderId = Int32.Parse(orderIdTextBox.Text);
		}
		catch(Exception ex)
		{
			MessageBox.Show(ex.Message);
			return;
		}

		// use an XPath query to select the order
		String xPathQuery = "/Orders_OrderDetails/Orders[OrderID = " + orderId + "]";
		XmlNode xmlNode = (new XmlDataDocument(ds)).SelectSingleNode(xPathQuery);

		StringBuilder result = new StringBuilder();

		if (xmlNode != null)
		{
			// retrieve the query results for the Order
			result.Append("OrderID = " + xmlNode.ChildNodes[0].InnerText + Environment.NewLine);
			result.Append("CustomerID = " + xmlNode.ChildNodes[1].InnerText + Environment.NewLine);
			result.Append("OrderDate = " + xmlNode.ChildNodes[3].InnerText + Environment.NewLine);
			result.Append("Line Items:" + Environment.NewLine);

			// retrieve the query results for the Order Details
			XmlNodeList xmlNodeList = xmlNode.SelectNodes("OrderDetails");
			for (int i = 0; i < xmlNodeList.Count; i++)
			{
				result.Append("\tProductID = " + xmlNodeList[i].ChildNodes[1].InnerText + Environment.NewLine);
				result.Append("\tQuantity = " + xmlNodeList[i].ChildNodes[2].InnerText + Environment.NewLine);
				result.Append("\tUnitPrice = " + xmlNodeList[i].ChildNodes[3].InnerText + Environment.NewLine + Environment.NewLine);
			}
		}
		else
		{
			result.Append("No data found for Order ID = " + orderId);
		}

		xPathQueryResultTextBox.Text = result.ToString();
	}
}