using System;
using System.Configuration;
using System.Windows.Forms;

using SQLXMLBULKLOADLib;

using System.Data;
using System.Data.SqlClient;

public class BulkInsertForm : System.Windows.Forms.Form
{
	private readonly String DATAFILENAME		= ConfigurationSettings.AppSettings["Project_Directory"] + @"Chapter 09\Customers.xml";
	private readonly String SCHEMAFILENAME		= ConfigurationSettings.AppSettings["Project_Directory"] + @"Chapter 09\Customers.xsd";
	private readonly String ERRORLOGFILENAME	= ConfigurationSettings.AppSettings["Temp_Directory"] + "BulkLoadError.log";
	
	private System.Windows.Forms.Button goButton;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public BulkInsertForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.goButton = new System.Windows.Forms.Button();
		this.SuspendLayout();
		// 
		// goButton
		// 
		this.goButton.Location = new System.Drawing.Point(208, 232);
		this.goButton.Name = "goButton";
		this.goButton.TabIndex = 0;
		this.goButton.Text = "Go";
		this.goButton.Click += new System.EventHandler(this.goButton_Click);
		// 
		// BulkInsertForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(292, 266);
		this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		this.goButton});
		this.Name = "BulkInsertForm";
		this.Text = "9.05 BulkInsertForm";
		this.ResumeLayout(false);

	}
	#endregion

	private void goButton_Click(object sender, System.EventArgs e)
	{
		// create the bulk load object, defining connection and error log
		SQLXMLBulkLoad bl = new SQLXMLBulkLoad();
		bl.ConnectionString = ConfigurationSettings.AppSettings["OleDb_Msde_ConnectString"];
		bl.ErrorLogFile = ERRORLOGFILENAME;

		// execute the bulk load
		try
		{
			bl.Execute(SCHEMAFILENAME, DATAFILENAME);
			MessageBox.Show("Bulk load completed successfully.", "Bulk Load", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}
		catch (Exception)
		{
			MessageBox.Show("ERROR. See " + ERRORLOGFILENAME + " for details.", "Bulk Load Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
		}
		finally
		{
			bl = null;
		}
	}
}