using System;
using System.Windows.Forms;

public class CompactAccessForm : System.Windows.Forms.Form
{
	private System.Windows.Forms.Button compactButton;
	private System.Windows.Forms.TextBox resultTextBox;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public CompactAccessForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.compactButton = new System.Windows.Forms.Button();
		this.resultTextBox = new System.Windows.Forms.TextBox();
		this.SuspendLayout();
		// 
		// compactButton
		// 
		this.compactButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
		this.compactButton.Location = new System.Drawing.Point(208, 232);
		this.compactButton.Name = "compactButton";
		this.compactButton.TabIndex = 0;
		this.compactButton.Text = "Compact";
		this.compactButton.Click += new System.EventHandler(this.compactButton_Click);
		// 
		// resultTextBox
		// 
		this.resultTextBox.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
			| System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right);
		this.resultTextBox.Location = new System.Drawing.Point(8, 8);
		this.resultTextBox.Multiline = true;
		this.resultTextBox.Name = "resultTextBox";
		this.resultTextBox.ReadOnly = true;
		this.resultTextBox.Size = new System.Drawing.Size(276, 216);
		this.resultTextBox.TabIndex = 1;
		this.resultTextBox.Text = "";
		// 
		// CompactAccessForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(292, 266);
		this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		this.resultTextBox,
																		this.compactButton});
		this.Name = "CompactAccessForm";
		this.Text = "10.10 CompactAccessForm";
		this.ResumeLayout(false);

	}
	#endregion

	private void compactButton_Click(object sender, System.EventArgs e)
	{
		// create the open file dialog object to get
		// the Access database to compact
		OpenFileDialog ofd = new OpenFileDialog();
		ofd.InitialDirectory = System.IO.Path.GetTempPath();
		// set the filter for Access databases
		ofd.Filter = "Microsoft Access (*.mdb)|*.mdb";

		// open the dialog
		if (ofd.ShowDialog() != DialogResult.OK)
			// return, if not user is not OK
			return;

		String sourceFileName = ofd.FileName;

		// create the save file dialog object to get
		// the filename for the compacted database
		SaveFileDialog sfd = new SaveFileDialog();
		sfd.InitialDirectory = System.IO.Path.GetTempPath();
		// set the filter for Access databases
		sfd.Filter = "Microsoft Access (*.mdb)|*.mdb";

		// open the dialog
		if (sfd.ShowDialog() == DialogResult.OK)
		{
			// if OK selected, compact the Access database
			resultTextBox.Text = "Beginning compact." + Environment.NewLine;
			resultTextBox.Refresh();

			String destFileName = sfd.FileName;

			// compact the database
			try
			{
				CompactAccessDatabase(sourceFileName, destFileName);

				resultTextBox.Text += "Finished compact.";
			}
			catch (System.Exception ex)
			{
				resultTextBox.Text += "ERROR: " + ex.Message;
			}
		}
	}

	private void CompactAccessDatabase(String sourceFileName, String destFileName)
	{
		// define connection string for original and compacted database 
		String sourceConnection = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + sourceFileName + ";";
		String destConnection = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + destFileName + ";";

		// create new Jet and Replication Objects (JRO) JetEngine object
		JRO.JetEngine je = new JRO.JetEngine();

		// compact the database
		try
		{
			je.CompactDatabase(sourceConnection, destConnection);
		}
		finally
		{
			je = null;
		}
	}
}