using System;
using System.Windows.Forms;

public class CreateAccessDatabaseForm : System.Windows.Forms.Form
{
	private System.Windows.Forms.Button createButton;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public CreateAccessDatabaseForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.createButton = new System.Windows.Forms.Button();
		this.SuspendLayout();
		// 
		// createButton
		// 
		this.createButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
		this.createButton.Location = new System.Drawing.Point(208, 232);
		this.createButton.Name = "createButton";
		this.createButton.TabIndex = 0;
		this.createButton.Text = "Create";
		this.createButton.Click += new System.EventHandler(this.createButton_Click);
		// 
		// CreateAccessDatabaseForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(292, 266);
		this.Controls.Add(this.createButton);
		this.Name = "CreateAccessDatabaseForm";
		this.Text = "10.06 CreateAccessDatabaseForm";
		this.ResumeLayout(false);

	}
	#endregion

	private void createButton_Click(object sender, System.EventArgs e)
	{
		// create the save file dialog object
		SaveFileDialog sfd = new SaveFileDialog();
		sfd.InitialDirectory = System.IO.Path.GetTempPath();
		// set the filter for Access databases
		sfd.Filter = "Microsoft Access (*.mdb)|*.mdb";

		// open the dialog
		if (sfd.ShowDialog() == DialogResult.OK)
		{
			// if OK selected, create the Access database
			String fileName = sfd.FileName;

			try
			{
				CreateAccessDatabase(fileName);

				MessageBox.Show("Microsoft Access database " + fileName + " created.", "Create Access Database", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
			catch (System.Exception ex)
			{
				MessageBox.Show("Could not create database " + fileName + ". " + ex.Message, "Create Access Database", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}
	}

	private void CreateAccessDatabase(String fileName)
	{
		String connectString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + fileName + ";";

		// use ADOX to create the Access database
		ADOX.Catalog cat = new ADOX.Catalog();
		try
		{
			cat.Create(connectString);
		}
		finally
		{
			cat = null;
		}
	}
}